import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Panel;

import quadbase.reportdesigner.designer.QbReportDesigner;
import quadbase.reportdesigner.util.ICustomDefinedFunctions;

// Run this example from Report Designer install directory
// Report manager must be running
public class RDWithCustomFunctions extends Applet implements ICustomDefinedFunctions {
	static final long serialVersionUID = 1;
	QbReportDesigner designer;

	public static void main(java.lang.String[] args) {
		try {
			RDWithCustomFunctions rd = new RDWithCustomFunctions();
			rd.doRDWithCustomFunctions(null);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		try {
			doRDWithCustomFunctions(this);
			setLayout(new BorderLayout());
			Panel panel = new Panel();
			panel.setLayout(new BorderLayout());
			panel.add("Center", new Label("LOADING"));
			add("Center", panel);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void doRDWithCustomFunctions(Applet applet) throws Exception {
		QbReportDesigner.setServerAddress("127.0.0.1");
		QbReportDesigner.setServerPortNumber(22071);

		QbReportDesigner.setUseSysResourceImages(true);

		designer = new QbReportDesigner(applet, "RDWithCustomFunctions.rpt");
		designer.setCustomDefinedFunctions(this);
		designer.setVisible(true);
	}

	public String[] getAllFunctionNames() {
		return new String[] { "inet_ntoa" };
	}

	public int getReturnType(String functionName) {
		if (functionName.equals("inet_ntoa")) {
			return STRING;
		}
		return -1;
	}

	public int[] getParamTypes(String functionName) {
		if (functionName.equals("inet_ntoa")) {
			return new int[] { NUMERIC };
		}
		return null;
	}

	public Object getValue(String functionName, Object[] args) throws Exception {
		if (functionName.equals("inet_ntoa")) {
			return "192.168.0." + ((Double) args[0]).intValue();
		}
		return null;
	}

}